Index: src/backend/access/transam/xlog.c
===================================================================
RCS file: /var/lib/cvs/pgsql-server/src/backend/access/transam/xlog.c,v
retrieving revision 1.125
diff -c -r1.125 xlog.c
*** src/backend/access/transam/xlog.c	27 Sep 2003 18:16:35 -0000	1.125
--- src/backend/access/transam/xlog.c	3 Nov 2003 02:46:57 -0000
***************
*** 1043,1048 ****
--- 1043,1060 ----
  			 */
  			if (openLogFile >= 0)
  			{
+ 				/*
+ 				 * Let the kernel know that we're not going to need
+ 				 * this WAL segment anymore, so there's no need to
+ 				 * keep it in the I/O cache
+ 				 */
+ 				if (posix_fadvise(openLogFile, 0, 0, POSIX_FADV_DONTNEED) != 0)
+ 				{
+ 					ereport(WARNING,
+ 							(errcode_for_file_access(),
+ 							 errmsg("could not posix_fadvise() log file %u: %m", openLogId)));
+ 				}
+ 
  				if (close(openLogFile) != 0)
  					ereport(PANIC,
  							(errcode_for_file_access(),
***************
*** 1159,1164 ****
--- 1171,1188 ----
  			if (openLogFile >= 0 &&
  			 !XLByteInPrevSeg(LogwrtResult.Write, openLogId, openLogSeg))
  			{
+ 				/*
+ 				 * Let the kernel know that we're not going to need
+ 				 * this WAL segment anymore, so there's no need to
+ 				 * keep it in the I/O cache
+ 				 */
+ 				if (posix_fadvise(openLogFile, 0, 0, POSIX_FADV_DONTNEED) != 0)
+ 				{
+ 					ereport(WARNING,
+ 							(errcode_for_file_access(),
+ 							 errmsg("could not posix_fadvise() log file %u: %m", openLogId)));
+ 				}
+ 
  				if (close(openLogFile) != 0)
  					ereport(PANIC,
  							(errcode_for_file_access(),
